--# -path=.:../Examples:    -- Pfad zu ANP.gf

concrete ANPEng of ANP = miniNPEng1 ** open Prelude in
{ lincat A = { s : Degree => Str } ;
         AP = { s : Degree => Str ; 
               s2 : Degree => Case => Str ;
               bare : Bool } ;
  lin small = mkA "small" ;
      Bush = regN "bush" "bushes" ;
      Tree1 = regN "maple" "maples" ;
      UseA a = { s = a.s ; s2 = \\d,c => [] ; bare = True } ;
      Compare a np = 
       { s = table{ Pos => "as" ++ a.s!Pos ;
                    Cmp => a.s!Cmp };
        s2 = table{ Pos => \\c => "as" ++ np.s!c ;
                    Cmp => \\c => "than" ++ np.s!c } ;
        bare = False } ;
  lin AttrPos ap cn =  -- AP zusammenhaengend
       \\n,c => case ap.bare of { True => ap.s!Pos ++ cn!n!c ++ ap.s2!Pos!c ;
                                     _ => cn!n!c ++ ap.s!Pos ++ ap.s2!Pos!c } ;
      AttrCmp ap cn =  -- AP zusammenhaengend
       \\n,c => case ap.bare of { True => ap.s!Cmp ++ cn!n!c ++ ap.s2!Cmp!c ;
                                     _ => cn!n!c ++ ap.s!Cmp ++ ap.s2!Cmp!c} ;

  oper regN : Str -> Str -> N ;
       mkA  : Str -> A ;
       N : Type = Number => Case => Str ;

  oper regN str str2 = table{Sg => table{ Gen => str+"'s" ; _ => str } ;
                             Pl => table{ Gen => str2+"'" ; _ => str2}} ;
       mkA str = lin A { s = table{Pos => str ; Cmp => str + "er"} } ;

  param Degree = Pos | Cmp ;
}         
